NDSummary.OnToolTipsLoaded("SystemVerilogClass:axi4stream_passthrough_agent",{335:"<div class=\"NDToolTip TClass LSystemVerilog\"><div class=\"TTSummary\">AXI4STREAM Passthrough Agent Class. The AXI4STREAM passthrough agent is comprised of other classes which are monitor,runtime master driver,&nbsp; runtime slave driver. By default, passthrough agent is in monitor mode. In order to issue transaction as master, it has to be switched to runtime master mode, in order to receive transaction, it has to be switched into runtime slave mode. Please refer PG 277 section about &quot;Useful Coding Guidelines and Examples&quot; for more details.</div></div>",337:"<div class=\"NDToolTip TInformation LSystemVerilog\"><div class=\"TTSummary\">axi4stream_mst_driver `XIL_AXI4STREAM_PARAM_ORDER mst_driver;</div></div>",339:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype339\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">function new</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\"><span class=\"SHKeyword\">string</span>&nbsp;</td><td class=\"PName\">name&nbsp;</td><td class=\"PDefaultValueSeparator\">=&nbsp;</td><td class=\"PDefaultValue last\"><span class=\"SHString\">&quot;unnamed_axi4stream_passthrough_agent&quot;</span>,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">virtual interface</span> axi4stream_vip_if `</td><td class=\"PType\">XIL_AXI4STREAM_PARAM_ORDER&nbsp;</td><td class=\"PName\">vif</td><td></td><td class=\"last\"></td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Constructor to create an AXI4STREAM Passthrough Agent. ~name~ is the instance name and axi4stream_vip_if is the interface in the design.&nbsp; Please see PG277 for how to find the interface in design hierarchy.</div></div>",988:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype988\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_verbosity(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">xil_verbosity&nbsp;</td><td class=\"PName last\">updated</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets the verbosity of the Agent and all sub classes.If updated is bigger than 300, it will print out necessary log message. Refer xil_info for verbosity information.</div></div>",341:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype341\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">function void</span> set_vif(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">axi4stream_vif_proxy `</td><td class=\"PType\">XIL_AXI4STREAM_PARAM_ORDER&nbsp;</td><td class=\"PName last\">vif</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets the Agent\'s virtual interface. This is the interface that will be monitored and/or driven.</div></div>",989:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype989\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_agent_tag(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">string</span>&nbsp;</td><td class=\"PName last\">updated</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets the tag of the Agent and all sub classes.If more than one VIPs(in master mode) being used in the same testbench, User can use set_agent_tag with different tag to tell where exactly the log message comes from.</div></div>",343:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype343\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> task start_monitor();</div><div class=\"TTSummary\">Enables the monitor in this agent to start collecting data in axi4stream_passthrough_agent.</div></div>",344:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype344\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> task start_slave();</div><div class=\"TTSummary\">Enables the monitor in this agent to start collecting data, enable slave driver to start drive ready signal.&nbsp; The slave driver will only issue axi4stream_ready_gen when the send functions are called.</div></div>",345:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype345\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> task start_master();</div><div class=\"TTSummary\">Enables the monitor in this agent to start collecting data, enables master driver to start drive data.&nbsp; The master driver will only issue transactions when the send functions are called.</div></div>",346:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype346\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> task stop_master();</div><div class=\"TTSummary\">Disables the driver of the master. Once disabled, no further action will occur by the drivers.</div></div>",347:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype347\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> task stop_slave();</div><div class=\"TTSummary\">Disables the driver of the slave. Once disabled, no further action will occur by the drivers.</div></div>",991:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype991\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> task stop_monitor();</div><div class=\"TTSummary\">Disables the monitor in this agent from start collecting data. Once disabled, no further action will occur by the monitor.</div></div>"});