NDSummary.OnToolTipsLoaded("SystemVerilogClass:axi4stream_ready_gen",{260:"<div class=\"NDToolTip TClass LSystemVerilog\"><div class=\"TTSummary\">AXI4Stream Ready generation class. Ready signal of AXI4STREAM VIP is generated independently from other attributes.&nbsp; This class is being used to generate all kinds of different patterns of ready signal which user wants. Please refer section READY Generation of PG277 for more details about how to generate ready.</div></div>",262:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype262\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">function new</span>(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\"><span class=\"SHKeyword\">string</span>&nbsp;</td><td class=\"PName\">name</td><td class=\"PDefaultValueSeparator\">=&nbsp;</td><td class=\"PDefaultValue last\"><span class=\"SHString\">&quot;unnamed_axi4stream_ready_gen&quot;</span></td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Constructor to create an new axi4stream_ready_gen, ~name~ is the name of the instance.</div></div>",263:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype263\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function void</span> reset_to_defaults();</div><div class=\"TTSummary\">Reset all variables in ready generation to default value</div></div>",264:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype264\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">function void</span> copy(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">axi4stream_ready_gen&nbsp;</td><td class=\"PName last\">rhs</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Copies the contents of the input ready generation to the current ready generation</div></div>",265:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype265\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function</span> axi4stream_ready_gen my_clone ();</div><div class=\"TTSummary\">Clones the current ready generaton and returns a handle to the new generation</div></div>",266:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype266\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function string</span> convert2string();</div><div class=\"TTSummary\">Returns&nbsp; a form of string of axi4stream_ready_gen.</div></div>",267:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype267\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function void</span> set_use_variable_ranges();</div><div class=\"TTSummary\">Sets the use of the variable ranges when the policy of axi4stream_ready_gen is not RANDOM</div></div>",268:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div class=\"TTSummary\">Clears the use of the variable ranges when the policy of axi4stream_ready_gen is not RANDOM</div></div>",269:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype269\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function</span> xil_axi4stream_boolean_t get_use_variable_ranges();</div><div class=\"TTSummary\">Returns the current state of the variable range use feature.</div></div>",270:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype270\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_ready_policy(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_ready_gen_policy_t&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets the policy of axi4stream_ready_gen</div></div>",271:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype271\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function</span> xil_axi4stream_ready_gen_policy_t get_ready_policy();</div><div class=\"TTSummary\">Returns the current axi4stream_ready_gen policy</div></div>",272:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype272\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_event_cycle_count_reset(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Set event_cycle_count_reset value of axi4stream_ready_gen</div></div>",273:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype273\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function</span> xil_axi4stream_uint get_event_cycle_count_reset();</div><div class=\"TTSummary\">Returns the current event_cycle_count_reset</div></div>",274:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype274\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> get_low_time_range(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">output&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">min,</td></tr><tr><td class=\"PModifierQualifier first\">output&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">max</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Returns min_low_time and max_low_time of the current axi4stream_ready_gen</div></div>",275:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype275\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_low_time_range(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">min,</td></tr><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">max</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets min_low_time and max_low_time of the current axi4stream_ready_gen</div></div>",276:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype276\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_low_time(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets low_time of the current axi4stream_ready_gen</div></div>",277:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype277\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function</span> xil_axi4stream_uint get_low_time();</div><div class=\"TTSummary\">Returns low time of the current axi4stream_ready_gen</div></div>",278:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype278\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> get_high_time_range(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">output&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">min,</td></tr><tr><td class=\"PModifierQualifier first\">output&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">max</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Returns min_high_time and max_high_time of the current axi4stream_ready_gen</div></div>",279:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype279\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_high_time_range(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">min,</td></tr><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">max</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets min_high_time and max_high_time of the current axi4stream_ready_gen</div></div>",280:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype280\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_high_time(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets high_time of the current axi4stream_ready_gen</div></div>",281:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype281\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function</span> xil_axi4stream_uint get_high_time();</div><div class=\"TTSummary\">Returns high time of the current axi4stream_ready_gen</div></div>",282:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype282\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> get_event_count_range(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">output&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">min,</td></tr><tr><td class=\"PModifierQualifier first\">output&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">max</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Returns min_event_count and max_event_count of the current axi4stream_ready_gen</div></div>",283:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype283\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_event_count_range(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">min,</td></tr><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">max</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets min_event_count and max_event_count of the current axi4stream_ready_gen</div></div>",284:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype284\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function</span> xil_axi4stream_uint get_event_count();</div><div class=\"TTSummary\">Returns event_count of the current axi4stream_ready_gen</div></div>",285:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype285\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual function void</span> set_event_count(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">input&nbsp;</td><td class=\"PType\">xil_axi4stream_uint&nbsp;</td><td class=\"PName last\">in</td></tr></table></td><td class=\"PAfterParameters\">);</td></tr></table></div><div class=\"TTSummary\">Sets the number of events that ready stays at high</div></div>",286:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype286\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function</span> xil_axi4stream_ready_rand_policy_t get_ready_rand_policy();</div><div class=\"TTSummary\">Returns ready_rand_policy of the axi4stream_ready_gen</div></div>",287:"<div class=\"NDToolTip TFunction LSystemVerilog\"><div id=\"NDPrototype287\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual function void</span> cheap_random();</div><div class=\"TTSummary\">Generate simplified randomization of ready class when user defines XIL_DO_NOT_USE_ADV_RANDOMIZATION</div></div>"});